package com.simuwang.shiro.core.adapter;

import cn.hutool.core.collection.ListUtil;
import com.simuwang.base.pojo.SysUser;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @author wangzaijun
 * @date 2024/9/6 17:44
 * @description 认证与授权的用户信息适配器（访问数据库和缓存）
 */
@Component
public class SimpleAuthAdapter implements AuthAdapter {
    @Override
    public SysUser findUserByUsername(String username) {
        SysUser sysUser = new SysUser();
        sysUser.setUserId("1");
        sysUser.setUsername("admin");
        return sysUser;
    }

    @Override
    public List<String> findRoleByUserId(String userId) {
        return ListUtil.toList("ADMIN");
    }

    @Override
    public List<String> findPermissionsByUserId(String userId) {
        return ListUtil.toList("1");
    }
}
