package com.simuwang.manage.api.company;

import com.simuwang.base.pojo.vo.CompanyEmailConfigVO;
import com.simuwang.manage.service.CompanyEmailConfigService;
import com.smppw.common.pojo.ResultVo;
import com.smppw.common.pojo.enums.status.ResultCode;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * FileName: CompanyInformationController
 * Author:   chenjianhua
 * Date:     2024/9/6 15:25
 * Description: ${DESCRIPTION}
 */
@RestController
@RequestMapping("/company")
public class CompanyEmailConfigController {
    private static final Logger logger = LoggerFactory.getLogger(CompanyEmailConfigController.class);
    @Autowired
    private CompanyEmailConfigService companyEmailConfigService;
    @PostMapping("save-email-config")
    public ResultVo saveCompanyEmailConfig(@RequestBody List<CompanyEmailConfigVO> companyEmailConfigVOS){
        ResultVo vo = new ResultVo(ResultCode.SAVE_SUCCESS);
        try{
            companyEmailConfigService.saveCompanyEmailConfig(companyEmailConfigVOS);
        }catch (Exception e){
            vo = new ResultVo(ResultCode.SAVE_SUCCESS);
            logger.error(e.getMessage(),e);
        }
        return vo;
    }

    @PostMapping("delete-email-config")
    public ResultVo deleteCompanyEmailConfig(@RequestParam("id")Integer id){
        ResultVo vo = new ResultVo(ResultCode.DELETE_SUCCESS);
        try{
            companyEmailConfigService.deleteCompanyEmailConfig(id);
        }catch (Exception e){
            vo = new ResultVo(ResultCode.DELETE_FAILED);
            logger.error(e.getMessage(),e);
        }
        return vo;
    }
}
